﻿using AsReaderA24DMAUIDemo.Platforms.Droid;

namespace AsReaderA24DMAUIDemo;

public partial class InformationPage : ContentPage
{
    private AsReaderA24DManager formManager;
    private AsReaderA24DDelegate asReaderA24DDelegate;

    public InformationPage()
    {
        InitializeComponent();
        formManager = AsReaderA24DManager.sharedInstance();
        asReaderA24DDelegate = AsReaderA24DDelegate.sharedInstance();
    }
    protected override void OnAppearing()
    {
        base.OnAppearing();
        asReaderA24DDelegate.OnConnect = (bool connect) =>
        {
            OnConnect(connect);
        };
        asReaderA24DDelegate.OnReaderInfoReceived = (Dictionary<string, string> info) =>
        {
            OnReaderInfoReceived(info);
        };
        formManager.GetReaderInfo();
    }
    protected override void OnDisappearing()
    {
        base.OnDisappearing();
        asReaderA24DDelegate.OnConnect = null;
    }
    private void OnConnect(bool connect)
    {
        MainThread.BeginInvokeOnMainThread(() =>
        {
            if (!connect)
            {
                Navigation.PopToRootAsync();
            }
        });
    }
    private void OnReaderInfoReceived(Dictionary<string, string> info)
    {
        MainThread.BeginInvokeOnMainThread(() =>
        {
            dllVersionLabel.Text = formManager.GetAsReaderA24DSDKDLL();
            sdkVersionLabel.Text = formManager.GetSDKVersion();
            modelLabel.Text = info["KeyInfo_ModelName"];
            hwvLabel.Text = info["KeyInfo_HardwareVersion"];
            fwvLabel.Text = info["KeyInfo_FirmwareVersion"];
        });
    }
    private void OnRefreshClicked(object sender, EventArgs e)
    {
        dllVersionLabel.Text = "";
        sdkVersionLabel.Text = "";
        modelLabel.Text = "";
        hwvLabel.Text = "";
        fwvLabel.Text = "";
        formManager.GetReaderInfo();
    }
}
