﻿using static AsReaderA24DMAUIDemo.Platforms.Droid.AsReaderA24DDefine;

namespace AsReaderA24DMAUIDemo.Platforms.Droid
{
	public class AsReaderA24DDelegate
    {
        public delegate void OnConnectDelegate(bool isConnect);
        public OnConnectDelegate OnConnect;

        public delegate void OnBatteryStateReceivedDelegate(int battery);
        public OnBatteryStateReceivedDelegate OnBatteryStateReceived;

        public delegate void OnReaderInfoReceivedDelegate(Dictionary<string, string> info);
        public OnReaderInfoReceivedDelegate OnReaderInfoReceived;

        public delegate void OnDeviceManagerErrorDelegate(AsReaderA24D_ErrorCode code);
        public OnDeviceManagerErrorDelegate OnDeviceManagerError;

        public delegate void OnBarcodeManagerErrorDelegate(AsReaderA24D_BarcodeManagerError code);
        public OnBarcodeManagerErrorDelegate OnBarcodeManagerError;

        public delegate void OnReceivedBarcodeDecodeDataDelegate(string decodeData, Dictionary<string, string> parameter);
        public OnReceivedBarcodeDecodeDataDelegate OnReceivedBarcodeDecodeData;

        public delegate void OnReceivedBarcodeDecodeByteDataDelegate(byte[] decodeData);
        public OnReceivedBarcodeDecodeByteDataDelegate OnReceivedBarcodeDecodeByteData;

        static AsReaderA24DDelegate uniqueInstance;

        static readonly object locker = new object();

        public static AsReaderA24DDelegate sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderA24DDelegate();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderA24DDelegate()
        {

        }
    }
}

